BROCLK - Editorial

I solved it using a function similar to modular exponentiation.
\cos tx = 2\cos^2(t/2) - 1 for even t
\cos tx = 2\cos(\lfloor t/2 \rfloor) \cos(\lceil t/2 \rceil) - \cos x for odd t

Simple recursive function with memoization passes. Though I couldn’t derive an upper bound on number distinct recursive calls. I guess its around 2 * \log t.

Link: CodeChef: Practical coding for everyone

You seriously need better editorialists.

2 Likes

Really good problem… never used matrix exponentiation like fibonacci’s anywhere else before

1 Like

Can someone help me understand the formula manipulation to get from the first matrix representation of the formula to the second one with the second 2x2 matrix raised to the (t-1) power?

I calculated cosnx by breaking n into a sum of powers of 2 and then calculated each power recursively using the formula cos2x=2cos^2-1. I used memoization to avoid repeating the same calculations. This required no more than log(n) operations.

To combine the powers of 2, I used the formula cos(a+b)=2cos(a)cos(b)-cos(a-b). I also used memoisation in this approach by mapping the previously calculated values of cosx otherwise it would result in TLE.

Link to my solution

2 Likes

@r_64 halin ren how to read ur page in english

need some help!
first i found out the angle with respect to positive y axis here

double angle=acos((double)D/I)

then i found the angle with respect to y axis after t seconds as this

angle=angle*T; // the final angle

  ll rem=angle/(2*pi);
  angle-=rem*(2*pi); // here we got the final angle

now I found the quadrant where the final angle will lie and calculate the value of d(the final y coordinate)

the i converted d into fraction using the function

and just find the inverse and print it where i am wrong

my solution my solution for BROCLK

hey everybody,
I found the x correctly. using cos(x) = d/l;
now why does doesn’t we get the final length by cos(x*t) this can +ve or -ve depending on the quadrent.
I believe cos will take care of everything as it changes the quadrent it switched the sign of value i.e from -ve to +ve or vice versa.
Please confirm… my broken code is https://www.codechef.com/viewsolution/17355814

After finding x, and also given t, why can’t we straight away find cos(tx)?

There is no need to use matrices or trigonometry at all. In my solution, all you need to know is how to deal with complex numbers.

First, swap X and Y coords for convenience. Then, we have complex number (d/l, sqrt(1-(d/l)^2)). Note, that real part of its Nth power times l is the answer, according to properties of complex number multiplication. But its imaginary part is irrational, how do we tackle that?

Let’s denote that nasty root sqrt(1-(d/l)^2) as R. Take a look at what happens when we multiplying complex numbers that looks like (a, b*R):

(a+b*R*i) * (c+d*R*i) = (a*c-b*d*R*R) + (ad+bc*R)*i = (a*c-b*d*(1-d/l)) + (ad+bc)*R*i

As we can see, field of numbers of that kind is closed under multiplication. So, all we need is to store complex number (a, b*R) as a pair of integers (a, b), write our own multiplication function, and use binpow.


[1]


  [1]: https://www.codechef.com/viewsolution/17300590

When I use the normal iterative to compute the chebyshev and fermat’s little theorem for modular inverse,
I get wrong answer on the first subtask.

The given test cases are computed right tho, and yes, I need something better for when t is large
but could someone tell me what’s wrong in this code, at least for t <= 3?

https://www.codechef.com/viewsolution/17436393

@vijju123 @r_64

There is other way to solve the question. Below is my approach:

We know e^ix = cos(x) + isin(x)

=> e^inx = cos(nx) + isin(nx)

We know cos(nx) + isin(nx) = (cos(x) + isin(x))^n

After computing we would have cos(nx) = real((cos(x) + isin(x))^n)

The multiplication can can be done in logn.

Here is the code: https://www.codechef.com/viewsolution/17348197

@manjuransari at one place u used the line

t_x = (xn_x)%mod - ((((y_xn_y_x)%mod)*diff)%mod)%mod;

cant we write it as t_x = [(xn_x)- ((((y_xn_y_x))*diff))]%mod;

i.e after multiplying all the values at last we are calculating mod

why using mod everytime as question clearly mentions you have to give FINAL result as ans%mod

why using mod every time will not affect our answer

Can someone please tell me what is wrong with this code??
solution

@albert it is possible that multiplying the two values may result in integer overflow. Hence after multiplying two values take mod, and then multiply with third value.

@manjuransari ok… thanks !!

i used binomial coefficients but iam getting wrong answer for some subtasks

If t=1, we return cos(tx)=(cos(x),0)and sin(tx)=(0,1);
Can anyone tell me why we are initializing sin(tx)=(0,1) ?

Can anyone please explain one example of this problem along with modular inverse calculation.

What is the problem if i do the following :

  1. \theta = \arccos(d/l)
  2. in order to find \cos(t* \theta), i find the equivalent form of t*theta as (k*2*pi + x) and compute \cos(x)*l to get the required y.

I find x as x = t* \theta - (int)(t* \theta/ \arctan(1)*8)* \theta

Is the problem due to floating point airthematic ?